#
# $Id: mcPartition.pm,v 1.3 2001/05/27 20:40:59 mcooper Exp $
#
# Partition object
#

package mcPartition;
require 5.003;

use mcMisc;
use mcPartInfo;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Entries"} = undef;

    bless ($self, $class);

    return $self;
}

sub Entries {
    my $self = shift;
    my $New;

    for my $Arg (@_) {
	if (ref($Arg) eq 'HASH') {
	    $New = $Arg;
	} else {
	    # Lookup and return result
	    return $self->{"Entries"}->{$Arg};
	}
    }

    if (!@_) {
	return $self->{"Entries"};
    }

    my $h = $self->{"Entries"};
    my @NewKey = keys %$New;
    my $NewVal = $New->{$NewKey[0]};
    $h->{$NewKey[0]} = $NewVal; # Overwrite old value
    $self->{"Entries"} = $h;

    return;
}

#
# Decode an array of general fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (!Eq($Fields[0], "partition")) {
	return;
    }

    my $Name = $Fields[4];
    my $PartInfo = mcPartInfo->New;
    # Lookup the PartInfo entry (if any)
    my $pi = $self->Entries($Name);
    if (!$pi) {
	# Need a new object
	$pi = $PartInfo;
    }
    # Decode and Set
    $pi->Decode(@Fields);
    # Add it back
    $self->Entries({$Name => $pi});

    return $self;
}

1; # Make require/use happy
